#/function terra_system:items/misc/gold/give
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Don't display equip message
#DontMakeSound Temp - Don't make sound on equipping
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge, 3 = replace item
#MessageMethod Temp - What method to display message to player - default = actionbar, 1 = chat
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function
#WeaponSlot Temp - Slot weapon should be equipped to - default = 1
#Offhand Temp - If replace item should place weapon in offhand

function terra_system:items/on_give1

#Give item
execute unless score Method Temp matches 1.. run give @s minecraft:gold_block{display:{Name:'{"translate":"terra.items.gold","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:7,ItemTags:["Item_MiscGold","Misc","Gold"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:gold_block",Count:1b,tag:{display:{Name:'{"translate":"terra.items.gold","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:7,ItemTags:["Item_MiscGold","Misc","Gold"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:gold_block",Count:1b,tag:{display:{Name:'{"translate":"terra.items.gold","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:7,ItemTags:["Item_MiscGold","Misc","Gold"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Replace item
execute if score Method Temp matches 3 run replaceitem entity @s weapon.mainhand minecraft:gold_block{display:{Name:'{"translate":"terra.items.gold","color":"white","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.rarity.common","color":"white"}']},RepairCost:100,Unbreakable:1,AttributeModifiers:[],HideFlags:7,ItemTags:["Item_MiscGold","Misc","Gold"]}

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.gold","color":"white"}',CustomNameVisible:1}
execute if score CustomName Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.gold","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_MiscGold"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_MiscGold"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run tellraw @s {"translate":"","extra":[{"score":{"name":"Amount","objective":"Temp"}},{"translate":"x ["},{"translate":"terra.items.gold","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.obtained"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run title @s actionbar {"translate":"","extra":[{"score":{"name":"Amount","objective":"Temp"}},{"translate":"x ["},{"translate":"terra.items.gold","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.obtained"}]}

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/misc/gold/give

	
	
		
#Clean up
function terra_system:items/on_give3


